//
// This code was generated by Enunciate.
// http://enunciate.codehaus.org/
//
#include <time.h>
#include <string.h>
#include <stdlib.h>
#include <libxml/xmlwriter.h>
#include <libxml/xmlreader.h>

#ifndef DEBUG_ENUNCIATE
#define DEBUG_ENUNCIATE 0
#endif

#ifndef ENUNCIATE_C_UTILITIES
#define ENUNCIATE_C_UTILITIES

/**
 * A basic xml node, used when (de)serializing unknown or "any" xml type.
 * We can't use the libxml xmlNodePtr because we can't reliably "free" it.
 */
struct xmlBasicNode {
  /**
   * The (local) name of the node.
   */
  xmlChar *name;

  /**
   * The namespace of the node.
   */
  xmlChar *ns;

  /**
   * The namespace prefix of the node.
   */
  xmlChar *prefix;

  /**
   * The (text) value of the node.
   */
  xmlChar *value;

  /**
   * The child elements of the node.
   */
  struct xmlBasicNode *child_elements;

  /**
   * The attributes of the node.
   */
  struct xmlBasicNode *attributes;

  /**
   * The next sibling (for a list of nodes).
   */
  struct xmlBasicNode *sibling;
};

/*******************xml utilities************************************/

static int xmlTextReaderAdvanceToNextStartOrEndElement(xmlTextReaderPtr reader) {
  int status = xmlTextReaderRead(reader);
  while (status && xmlTextReaderNodeType(reader) != XML_READER_TYPE_ELEMENT && xmlTextReaderNodeType(reader) != XML_READER_TYPE_END_ELEMENT) {
    status = xmlTextReaderRead(reader);
  }
  return status;
}

static int xmlTextReaderSkipElement(xmlTextReaderPtr reader) {
  int status = xmlTextReaderNext(reader);
  while (status && xmlTextReaderNodeType(reader) != XML_READER_TYPE_ELEMENT && xmlTextReaderNodeType(reader) != XML_READER_TYPE_END_ELEMENT) {
    status = xmlTextReaderRead(reader);
  }
  return status;
}

static xmlChar *xmlTextReaderReadEntireNodeValue(xmlTextReaderPtr reader) {
  xmlChar *buffer = calloc(1, sizeof(xmlChar));
  const xmlChar *snippet;
  int status;
  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ATTRIBUTE) {
    return xmlTextReaderValue(reader);
  }
  else if (xmlTextReaderIsEmptyElement(reader) == 0) {
    status = xmlTextReaderRead(reader);
    while (status && (xmlTextReaderNodeType(reader) == XML_READER_TYPE_TEXT || xmlTextReaderNodeType(reader) == XML_READER_TYPE_CDATA || xmlTextReaderNodeType(reader) == XML_READER_TYPE_ENTITY_REFERENCE)) {
      snippet = xmlTextReaderConstValue(reader);
      buffer = realloc(buffer, (xmlStrlen(buffer) + xmlStrlen(snippet) + 1) * sizeof(xmlChar));
      xmlStrcat(buffer, snippet);
      status = xmlTextReaderRead(reader);
    }
  }
  return buffer;
}

/*******************base 64 utilities************************************/

/*
 * Base64 Translation Table as described in RFC1113.
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 */
static const char cb64[]="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";

/*
 * Base64 Translation Table to decode (created by author)
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 */
static const char cd64[]="|$$$}rstuvwxyz{$$$$$$$>?@ABCDEFGHIJKLMNOPQRSTUVW$$$$$$XYZ[\\]^_`abcdefghijklmnopq";

/*
 * encode 3 8-bit binary bytes as 4 '6-bit' characters
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 *
 * @param in the block to encode
 * @param out the block to encode to
 * @param len the length of the 'in' block.
 */
static void _encode_base64_block(unsigned char in[3], unsigned char out[4], int len) {
  out[0] = cb64[ in[0] >> 2 ];
  out[1] = cb64[ ((in[0] & 0x03) << 4) | ((in[1] & 0xf0) >> 4) ];
  out[2] = (unsigned char) (len > 1 ? cb64[ ((in[1] & 0x0f) << 2) | ((in[2] & 0xc0) >> 6) ] : '=');
  out[3] = (unsigned char) (len > 2 ? cb64[ in[2] & 0x3f ] : '=');
}

/*
 * decode 4 '6-bit' characters into 3 8-bit binary bytes
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 */
static void _decode_base64_block( unsigned char in[4], unsigned char out[3] )
{
    out[ 0 ] = (unsigned char ) (in[0] << 2 | in[1] >> 4);
    out[ 1 ] = (unsigned char ) (in[1] << 4 | in[2] >> 2);
    out[ 2 ] = (unsigned char ) (((in[2] << 6) & 0xc0) | in[3]);
}

/*
 * base64 encode a stream adding padding and line breaks as per spec.
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 *
 * @param instream The stream to encode.
 * @param insize The size of the stream to encode.
 * @return The encoded string.
 */
xmlChar *_encode_base64(unsigned char *instream, int insize) {
  unsigned char in[3];
  unsigned char out[4];
  xmlChar *encoded;
  int i, in_index = 0, out_index = 0, blocklen;

  if (insize == 0) {
    return BAD_CAST "\0";
  }

  encoded = calloc(((insize / 3) * 4) + 10, sizeof(xmlChar));
  while (in_index <= insize) {
    blocklen = 0;
    for (i = 0; i < 3; i++) {
      in[i] = instream[in_index++];
      if (in_index <= insize) {
        blocklen++;
      }
      else {
        in[i] = 0;
      }
    }
    if (blocklen) {
      _encode_base64_block(in, out, blocklen);
      for( i = 0; i < 4; i++ ) {
        encoded[out_index++] = out[i];
      }
    }
  }

  return encoded;
}

/*
 * Decode a base64 encoded stream discarding padding, line breaks and noise
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 *
 * @param invalue The string to decode.
 * @param outsize Holder for the length of the returned data.
 * @return The decoded data.
 */
unsigned char *_decode_base64( const xmlChar *invalue, int *outsize ) {
  xmlChar in[4];
  unsigned char out[3], v;
  int i, in_index = 0, out_index = 0, blocklen;
  unsigned char *outstream;

  if (invalue == NULL) {
    return NULL;
  }

  outstream = calloc(((xmlStrlen(invalue) / 4) * 3) + 1, sizeof(unsigned char));
  while (invalue[in_index] != '\0') {
    for (blocklen = 0, i = 0; i < 4 && invalue[in_index]; i++) {
      v = 0;
      while (invalue[in_index] != '\0' && v == 0) {
        v = (unsigned char) invalue[in_index++];
        v = (unsigned char) ((v < 43 || v > 122) ? 0 : cd64[ v - 43 ]);
        if (v) {
          v = (unsigned char) ((v == '$') ? 0 : v - 61);
        }
      }

      if (invalue[in_index] != '\0') {
        blocklen++;
        if (v) {
          in[i] = (unsigned char) (v - 1);
        }
      }
      else {
        in[i] = 0;
      }
    }

    if (blocklen) {
      _decode_base64_block( in, out );
      for( i = 0; i < blocklen - 1; i++ ) {
        outstream[out_index++] = out[i];
      }
    }
  }

  if (outsize != NULL) {
    *outsize = out_index;
  }

  return outstream;
}

#endif /* ENUNCIATE_C_UTILITIES */

#ifndef BASIC_XML_FUNCTIONS_Xs
#define BASIC_XML_FUNCTIONS_Xs

/*******************xs:boolean************************************/

/**
 * Read a boolean value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to 1 if "true" was read. pointer to 0 otherwise.
 */
static int *xmlTextReaderReadXsBooleanType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  int *value = malloc(sizeof(int));
  *value = (xmlStrcmp(BAD_CAST "true", nodeValue) == 0) ? 1 : 0;
  free(nodeValue);
  return value;
}

/**
 * Write a boolean value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsBooleanType(xmlTextWriterPtr writer, int *value) {
  if (*value) {
    return xmlTextWriterWriteString(writer, BAD_CAST "false");
  }
  else {
    return xmlTextWriterWriteString(writer, BAD_CAST "true");
  }
}

/**
 * Frees a boolean type from memory.
 *
 * @param value The value to free.
 */
static void freeXsBooleanType(int *value) {
  //no-op
}

/*******************xs:byte************************************/

/**
 * Read a byte value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the byte.
 */
static unsigned char *xmlTextReaderReadXsByteType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  unsigned char *value = malloc(sizeof(unsigned char));
  *value = (unsigned char) atoi((char *) nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a byte value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsByteType(xmlTextWriterPtr writer, unsigned char *value) {
  return xmlTextWriterWriteFormatString(writer, "%i", *value);
}

/**
 * Frees a byte type from memory.
 *
 * @param value The value to free.
 */
static void freeXsByteType(unsigned char *value) {
  //no-op
}

/*******************xs:double************************************/

/**
 * Read a double value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the double.
 */
static double *xmlTextReaderReadXsDoubleType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  double *value = malloc(sizeof(double));
  *value = atof((char *) nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a double value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDoubleType(xmlTextWriterPtr writer, double *value) {
  return xmlTextWriterWriteFormatString(writer, "%f", *value);
}

/**
 * Frees a double type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDoubleType(double *value) {
  //no-op
}

/*******************xs:float************************************/

/**
 * Read a float value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the float.
 */
static float *xmlTextReaderReadXsFloatType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  float *value = malloc(sizeof(float));
  *value = atof((char *)nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a float value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsFloatType(xmlTextWriterPtr writer, float *value) {
  return xmlTextWriterWriteFormatString(writer, "%f", *value);
}

/**
 * Frees a float type from memory.
 *
 * @param value The value to free.
 */
static void freeXsFloatType(float *value) {
  //no-op
}

/*******************xs:int************************************/

/**
 * Read a int value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @param value The value to be written.
 * @return pointer to the int.
 */
static int *xmlTextReaderReadXsIntType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  int *value = malloc(sizeof(int));
  *value = atoi((char *)nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a int value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsIntType(xmlTextWriterPtr writer, int *value) {
  return xmlTextWriterWriteFormatString(writer, "%i", *value);
}

/**
 * Frees a int type from memory.
 *
 * @param value The value to free.
 */
static void freeXsIntType(int *value) {
  //no-op
}

/*******************xs:long************************************/

/**
 * Read a long value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the long.
 */
static long *xmlTextReaderReadXsLongType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  long *value = malloc(sizeof(long));
  *value = atol((char *)nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a long value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsLongType(xmlTextWriterPtr writer, long *value) {
  return xmlTextWriterWriteFormatString(writer, "%ld", *value);
}

/**
 * Frees a long type from memory.
 *
 * @param value The value to free.
 */
static void freeXsLongType(long *value) {
  //no-op
}

/*******************xs:short************************************/

/**
 * Read a short value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the short.
 */
static short *xmlTextReaderReadXsShortType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  short *value = malloc(sizeof(short));
  *value = atoi((char *)nodeValue);
  return value;
}

/**
 * Write a short value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsShortType(xmlTextWriterPtr writer, short *value) {
  return xmlTextWriterWriteFormatString(writer, "%hi", *value);
}

/**
 * Frees a short type from memory.
 *
 * @param value The value to free.
 */
static void freeXsShortType(short *value) {
  //no-op
}

/*******************xs:string************************************/

/**
 * Read a string value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the string.
 */
static xmlChar *xmlTextReaderReadXsStringType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadEntireNodeValue(reader);
}

/**
 * Write a string value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsStringType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a string type from memory.
 *
 * @param value The value to free.
 */
static void freeXsStringType(xmlChar *value) {
  //no-op
}

/*******************xs:ID************************************/

/**
 * Read a ID value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the ID.
 */
static xmlChar *xmlTextReaderReadXsIDType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a ID value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsIDType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a ID type from memory.
 *
 * @param value The value to free.
 */
static void freeXsIDType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:IDREF************************************/

/**
 * Read a IDREF value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the IDREF.
 */
static xmlChar *xmlTextReaderReadXsIDREFType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a IDREF value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsIDREFType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a IDREF type from memory.
 *
 * @param value The value to free.
 */
static void freeXsIDREFType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:integer************************************/

/**
 * Read a (big) integer value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the integer.
 */
static xmlChar *xmlTextReaderReadXsIntegerType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a integer value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsIntegerType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a integer type from memory.
 *
 * @param value The value to free.
 */
static void freeXsIntegerType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:decimal************************************/

/**
 * Read a (big) decimal value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the decimal.
 */
static xmlChar *xmlTextReaderReadXsDecimalType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a decimal value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDecimalType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a decimal type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDecimalType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:duration************************************/

/**
 * Read a duration value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the duration.
 */
static xmlChar *xmlTextReaderReadXsDurationType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a duration value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDurationType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a duration type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDurationType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:QName************************************/

/**
 * Read a QName value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the QName.
 */
static xmlChar *xmlTextReaderReadXsQNameType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a QName value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsQNameType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a QName type from memory.
 *
 * @param value The value to free.
 */
static void freeXsQNameType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:anyURI************************************/

/**
 * Read a anyURI value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the anyURI.
 */
static xmlChar *xmlTextReaderReadXsAnyURIType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a anyURI value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnyURIType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a anyURI type from memory.
 *
 * @param value The value to free.
 */
static void freeXsAnyURIType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:dateTime************************************/

/**
 * Read a dateTime value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the dateTime.
 */
static struct tm *xmlTextReaderReadXsDateTimeType(xmlTextReaderPtr reader) {
  struct tm * time = calloc(1, sizeof(struct tm));
  xmlChar *timevalue = xmlTextReaderReadEntireNodeValue(reader);
  int success = 0, index = 0, token_index = 0, len = xmlStrlen(timevalue), offset_hours = 0, offset_min = 0;
  char token[len];

  //date time format: yyyy-mm-ddThh:MM:ss+oo:oo
  //go to first '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_year = atoi(token) - 1900;
  if (token_index > 0) {
    success++; //assume 'year' was successfully read.
    index++;
  }

  //go to next '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_mon = atoi(token) - 1;
  if (token_index > 0) {
    success++; //assume 'month' was successfully read.
    index++;
  }

  //go to 'T' character.
  token_index = 0;
  while (index < len && timevalue[index] != 'T') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_mday = atoi(token);
  if (token_index > 0) {
    success++; //assume 'day' was successfully read.
    index++;
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_hour = atoi(token);
  if (token_index > 0) {
    success++; //assume 'hour' was successfully read.
    index++;
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_min = atoi(token);
  if (token_index > 0) {
    success++; //assume 'minutes' was successfully read.
    index++;
  }

  //go to '+' or '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '+' && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_sec = atof(token);
  if (token_index > 0) {
    success++; //assume 'seconds' was successfully read.
    if (timevalue[index] == '+') {
      index++;
    }
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_hours = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset hours was successfully read.
    index++;
  }

  //go to end.
  token_index = 0;
  while (index < len) {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_min = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset minutes was successfully read.
    index++;
  }
  time->tm_gmtoff = ((offset_hours * 60) + offset_min) * 60;

  free(timevalue);
  return time;
}

/**
 * Write a dateTime value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDateTimeType(xmlTextWriterPtr writer, struct tm *value) {
  return xmlTextWriterWriteFormatString(writer, "%04i-%02i-%02iT%02i:%02i:%02i.000%+03i:%02i", value->tm_year + 1900, value->tm_mon + 1, value->tm_mday, value->tm_hour, value->tm_min, value->tm_sec, (int) (value->tm_gmtoff / 3600), (int) ((value->tm_gmtoff / 60) % 60));
}

/**
 * Frees a dateTime type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDateTimeType(struct tm *value) {
  //no-op
}

/*******************xs:time************************************/

/**
 * Read a time value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the time.
 */
static struct tm *xmlTextReaderReadXsTimeType(xmlTextReaderPtr reader) {
  struct tm * time = calloc(1, sizeof(struct tm));
  xmlChar *timevalue = xmlTextReaderReadEntireNodeValue(reader);
  int success = 0, index = 0, token_index = 0, len = xmlStrlen(timevalue), offset_hours = 0, offset_min = 0;
  char token[len];

  //date time format: hh:MM:ss+oo:oo
  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_hour = atoi(token);
  if (token_index > 0) {
    success++; //assume 'hour' was successfully read.
    index++;
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_min = atoi(token);
  if (token_index > 0) {
    success++; //assume 'minutes' was successfully read.
    index++;
  }

  //go to '+' or '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '+' && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_sec = atof(token);
  if (token_index > 0) {
    success++; //assume 'seconds' was successfully read.
    if (timevalue[index] == '+') {
      index++;
    }
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_hours = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset hours was successfully read.
    index++;
  }

  //go to end.
  token_index = 0;
  while (index < len) {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_min = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset minutes was successfully read.
    index++;
  }
  time->tm_gmtoff = ((offset_hours * 60) + offset_min) * 60;

  free(timevalue);
  return time;
}

/**
 * Write a time value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsTimeType(xmlTextWriterPtr writer, struct tm *value) {
  return xmlTextWriterWriteFormatString(writer, "%02i:%02i:%02i.000%+03i:%02i", value->tm_hour, value->tm_min, value->tm_sec, (int) (value->tm_gmtoff / 3600), (int) ((value->tm_gmtoff / 60) % 60));
}

/**
 * Frees a time type from memory.
 *
 * @param value The value to free.
 */
static void freeXsTimeType(struct tm *value) {
  //no-op
}

/*******************xs:date************************************/

/**
 * Read a date value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the date.
 */
static struct tm *xmlTextReaderReadXsDateType(xmlTextReaderPtr reader) {
  struct tm * time = calloc(1, sizeof(struct tm));
  xmlChar *timevalue = xmlTextReaderReadEntireNodeValue(reader);
  int success = 0, index = 0, token_index = 0, len = xmlStrlen(timevalue), offset_hours = 0, offset_min = 0;
  char token[len];

  //date time format: yyyy-mm-dd+oo:oo
  //go to first '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_year = atoi(token) - 1900;
  if (token_index > 0) {
    success++; //assume 'year' was successfully read.
    index++;
  }

  //go to next '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_mon = atoi(token) - 1;
  if (token_index > 0) {
    success++; //assume 'month' was successfully read.
    index++;
  }

  //go to '+' or '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '+' && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_sec = atof(token);
  if (token_index > 0) {
    success++; //assume 'seconds' was successfully read.
    if (timevalue[index] == '+') {
      index++;
    }
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_hours = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset hours was successfully read.
    index++;
  }

  //go to end.
  token_index = 0;
  while (index < len) {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_min = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset minutes was successfully read.
    index++;
  }
  time->tm_gmtoff = ((offset_hours * 60) + offset_min) * 60;

  free(timevalue);
  return time;
}

/**
 * Write a date value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDateType(xmlTextWriterPtr writer, struct tm *value) {
  return xmlTextWriterWriteFormatString(writer, "%04i-%02i-%02i%+03i:%02i", value->tm_year + 1900, value->tm_mon + 1, value->tm_mday, (int) (value->tm_gmtoff / 3600), (int) ((value->tm_gmtoff / 60) % 60));
}

/**
 * Frees a date type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDateType(struct tm *value) {
  //no-op
}

/*******************xs:anyType************************************/

/**
 * Frees a anyType type from memory.
 *
 * @param node The node to free.
 */
static void freeXsAnyTypeType(struct xmlBasicNode *node) {
  if (node->attributes != NULL) {
    freeXsAnyTypeType(node->attributes);
  }
  if (node->value != NULL) {
    free(node->value);
  }
  if (node->child_elements != NULL) {
    freeXsAnyTypeType(node->child_elements);
  }
  if (node->name != NULL) {
    free(node->name);
  }
  if (node->prefix != NULL) {
    free(node->prefix);
  }
  if (node->ns != NULL) {
    free(node->ns);
  }
  if (node->sibling != NULL) {
    freeXsAnyTypeType(node->sibling);
    free(node->sibling);
  }
}

/**
 * Read a anyType value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the anyType., or NULL if error.
 */
static struct xmlBasicNode *xmlTextReaderReadXsAnyTypeType(xmlTextReaderPtr reader) {
  struct xmlBasicNode *child, *next, *node = calloc(1, sizeof(struct xmlBasicNode));
  int status, depth = xmlTextReaderDepth(reader);
  const xmlChar *text;

  node->name = xmlTextReaderLocalName(reader);
  node->ns = xmlTextReaderNamespaceUri(reader);
  node->prefix = xmlTextReaderPrefix(reader);

  if (xmlTextReaderHasAttributes(reader)) {
    child = NULL;
    while (xmlTextReaderMoveToNextAttribute(reader)) {
      next = calloc(1, sizeof(struct xmlBasicNode));
      if (child == NULL) {
        node->attributes = next;
      }
      else {
        child->sibling = next;
      }
      child = next;
      child->name = xmlTextReaderLocalName(reader);
      child->ns = xmlTextReaderNamespaceUri(reader);
      child->prefix = xmlTextReaderPrefix(reader);
      child->value = xmlTextReaderValue(reader);
    }

    status = xmlTextReaderMoveToElement(reader);
    if (status < 1) {
      //panic: unable to return to the element node.
      freeXsAnyTypeType(node);
      free(node);
      return NULL;
    }
  }

  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    status = xmlTextReaderRead(reader);
    while (status == 1 && xmlTextReaderDepth(reader) > depth) {
      switch (xmlTextReaderNodeType(reader)) {
        case XML_READER_TYPE_ELEMENT:
          child = xmlTextReaderReadXsAnyTypeType(reader);
          if (child == NULL) {
            //panic: xml read error
            freeXsAnyTypeType(node);
            free(node);
            return NULL;
          }

          next = node->child_elements;
          if (next == NULL) {
            node->child_elements = child;
          }
          else {
            while (1) {
              if (next->sibling == NULL) {
                next->sibling = child;
                break;
              }
              next = next->sibling;
            }
          }

          break;
        case XML_READER_TYPE_TEXT:
        case XML_READER_TYPE_CDATA:
          text = xmlTextReaderConstValue(reader);
          node->value = xmlStrncat(node->value, text, xmlStrlen(text));
          break;
        default:
          //skip anything else.
          break;
      }

      status = xmlTextReaderRead(reader);
    }

    if (status < 1) {
      //panic: xml read error
      freeXsAnyTypeType(node);
      free(node);
      return NULL;
    }
  }

  return node;
}

/**
 * Write a anyType value to the writer.
 *
 * @param writer The writer.
 * @param node The node to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnyTypeType(xmlTextWriterPtr writer, struct xmlBasicNode *node) {
  int status;
  int totalBytes = 0;
  struct xmlBasicNode *next;

  status = xmlTextWriterStartElementNS(writer, node->prefix, node->name, node->ns);
  if (status < 0) {
    return status;
  }
  totalBytes += status;

  next = node->attributes;
  while (next != NULL) {
    status = xmlTextWriterWriteAttributeNS(writer, next->prefix, next->name, next->ns, next->value);
    if (status < 0) {
      return status;
    }
    totalBytes += status;
    next = next->sibling;
  }

  if (node->value != NULL) {
    status = xmlTextWriterWriteString(writer, node->value);
    if (status < 0) {
      //panic: xml write error
      return status;
    }
    totalBytes += status;
  }

  next = node->child_elements;
  while (next != NULL) {
    status = xmlTextWriterWriteXsAnyTypeType(writer, next);
    if (status < 0) {
      return status;
    }
    totalBytes += status;
    next = next->sibling;
  }

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Read a anyType element value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the anyType., or NULL if error.
 */
static struct xmlBasicNode *xmlTextReaderReadXsAnyTypeElement(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsAnyTypeType(reader);
}

/**
 * Write a anyType element value to the writer.
 *
 * @param writer The writer.
 * @param node The node to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnyTypeElement(xmlTextWriterPtr writer, struct xmlBasicNode *node) {
  return xmlTextWriterWriteXsAnyTypeType(writer, node);
}

/**
 * Write a anyType element value to the writer.
 *
 * @param writer The writer.
 * @param node The node to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnyTypeElementNS(xmlTextWriterPtr writer, struct xmlBasicNode *node, int writeNamespaces) {
  return xmlTextWriterWriteXsAnyTypeType(writer, node);
}

/**
 * Free a anyType element value.
 *
 * @param node The node.
 */
static void freeXsAnyTypeElement(struct xmlBasicNode *node) {
  freeXsAnyTypeType(node);
}

/*******************xs:anySimpleType************************************/

/**
 * Frees a anyType type from memory.
 *
 * @param node The node to free.
 */
static void freeXsAnySimpleTypeType(struct xmlBasicNode *node) {
  freeXsAnyTypeType(node);
}

/**
 * Read a anyType value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the anyType., or NULL if error.
 */
static struct xmlBasicNode *xmlTextReaderReadXsAnySimpleTypeType(xmlTextReaderPtr reader) {
  struct xmlBasicNode *node = calloc(1, sizeof(struct xmlBasicNode));

  node->name = xmlTextReaderLocalName(reader);
  node->ns = xmlTextReaderNamespaceUri(reader);
  node->prefix = xmlTextReaderPrefix(reader);
  node->value = xmlTextReaderReadEntireNodeValue(reader);

  return node;
}

/**
 * Write a anyType value to the writer.
 *
 * @param writer The writer.
 * @param node The node to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnySimpleTypeType(xmlTextWriterPtr writer, struct xmlBasicNode *node) {
  if (node->value != NULL) {
    return xmlTextWriterWriteXsStringType(writer, node->value);
  }

  return 0;
}

#endif /* BASIC_XML_FUNCTIONS_Xs */

#ifndef DEF_nexus_plugin_console_plugin_ns0_pluginDocumentation_H
#define DEF_nexus_plugin_console_plugin_ns0_pluginDocumentation_H

/**
 * (no documentation provided)
 */
struct nexus_plugin_console_plugin_ns0_pluginDocumentation {


  /**
   * (no documentation provided)
   */
  xmlChar *label;

  /**
   * (no documentation provided)
   */
  xmlChar *url;
};

/**
 * Reads a DocumentationLinkDTO from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The DocumentationLinkDTO, or NULL in case of error.
 */
static struct nexus_plugin_console_plugin_ns0_pluginDocumentation *xmlTextReaderReadNs0PluginDocumentationType(xmlTextReaderPtr reader);

/**
 * Writes a DocumentationLinkDTO to XML.
 *
 * @param writer The XML writer.
 * @param _documentationLinkDTO The DocumentationLinkDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0PluginDocumentationType(xmlTextWriterPtr writer, struct nexus_plugin_console_plugin_ns0_pluginDocumentation *_documentationLinkDTO);

/**
 * Frees the elements of a DocumentationLinkDTO.
 *
 * @param _documentationLinkDTO The DocumentationLinkDTO to free.
 */
static void freeNs0PluginDocumentationType(struct nexus_plugin_console_plugin_ns0_pluginDocumentation *_documentationLinkDTO);

#endif /* DEF_nexus_plugin_console_plugin_ns0_pluginDocumentation_H */
#ifndef DEF_nexus_plugin_console_plugin_ns0_pluginInfo_H
#define DEF_nexus_plugin_console_plugin_ns0_pluginInfo_H

/**
 * (no documentation provided)
 */
struct nexus_plugin_console_plugin_ns0_pluginInfo {


  /**
   * (no documentation provided)
   */
  xmlChar *site;

  /**
   * (no documentation provided)
   */
  xmlChar *failureReason;

  /**
   * (no documentation provided)
   */
  xmlChar *status;

  /**
   * (no documentation provided)
   */
  xmlChar *name;

  /**
   * (no documentation provided)
   */
  xmlChar *description;

  /**
   * (no documentation provided)
   */
  xmlChar *version;

  /**
   * (no documentation provided)
   */
  xmlChar *scmVersion;

  /**
   * (no documentation provided)
   */
  xmlChar *scmTimestamp;

  /**
   * (no documentation provided)
   */
  struct nexus_plugin_console_plugin_ns0_restInfo *restInfos;

  /**
   * Size of the restInfos array.
   */
  int _sizeof_restInfos;

  /**
   * (no documentation provided)
   */
  struct nexus_plugin_console_plugin_ns0_pluginDocumentation *documentation;

  /**
   * Size of the documentation array.
   */
  int _sizeof_documentation;
};

/**
 * Reads a PluginInfoDTO from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The PluginInfoDTO, or NULL in case of error.
 */
static struct nexus_plugin_console_plugin_ns0_pluginInfo *xmlTextReaderReadNs0PluginInfoType(xmlTextReaderPtr reader);

/**
 * Writes a PluginInfoDTO to XML.
 *
 * @param writer The XML writer.
 * @param _pluginInfoDTO The PluginInfoDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0PluginInfoType(xmlTextWriterPtr writer, struct nexus_plugin_console_plugin_ns0_pluginInfo *_pluginInfoDTO);

/**
 * Frees the elements of a PluginInfoDTO.
 *
 * @param _pluginInfoDTO The PluginInfoDTO to free.
 */
static void freeNs0PluginInfoType(struct nexus_plugin_console_plugin_ns0_pluginInfo *_pluginInfoDTO);

#endif /* DEF_nexus_plugin_console_plugin_ns0_pluginInfo_H */
#ifndef DEF_nexus_plugin_console_plugin_ns0_pluginInfoListResponseDTO_H
#define DEF_nexus_plugin_console_plugin_ns0_pluginInfoListResponseDTO_H

/**
 * (no documentation provided)
 */
struct nexus_plugin_console_plugin_ns0_pluginInfoListResponseDTO {


  /**
   * (no documentation provided)
   */
  struct nexus_plugin_console_plugin_ns0_pluginInfo *data;

  /**
   * Size of the data array.
   */
  int _sizeof_data;
};

/**
 * Reads a PluginInfoListResponseDTO element from XML. The element to be read is "pluginInfos", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The PluginInfoListResponseDTO, or NULL in case of error.
 */
struct nexus_plugin_console_plugin_ns0_pluginInfoListResponseDTO *xml_read_nexus_plugin_console_plugin_ns0_pluginInfoListResponseDTO(xmlTextReaderPtr reader);

/**
 * Writes a PluginInfoListResponseDTO to XML under element name "pluginInfos".
 *
 * @param writer The XML writer.
 * @param _pluginInfoListResponseDTO The PluginInfoListResponseDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_plugin_console_plugin_ns0_pluginInfoListResponseDTO(xmlTextWriterPtr writer, struct nexus_plugin_console_plugin_ns0_pluginInfoListResponseDTO *_pluginInfoListResponseDTO);

/**
 * Frees a PluginInfoListResponseDTO.
 *
 * @param _pluginInfoListResponseDTO The PluginInfoListResponseDTO to free.
 */
void free_nexus_plugin_console_plugin_ns0_pluginInfoListResponseDTO(struct nexus_plugin_console_plugin_ns0_pluginInfoListResponseDTO *_pluginInfoListResponseDTO);

/**
 * Reads a PluginInfoListResponseDTO element from XML. The element to be read is "pluginInfos", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The PluginInfoListResponseDTO, or NULL in case of error.
 */
struct nexus_plugin_console_plugin_ns0_pluginInfoListResponseDTO *xmlTextReaderReadNs0PluginInfosElement(xmlTextReaderPtr reader);

/**
 * Writes a PluginInfoListResponseDTO to XML under element name "pluginInfos".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _pluginInfoListResponseDTO The PluginInfoListResponseDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0PluginInfosElement(xmlTextWriterPtr writer, struct nexus_plugin_console_plugin_ns0_pluginInfoListResponseDTO *_pluginInfoListResponseDTO);

/**
 * Writes a PluginInfoListResponseDTO to XML under element name "pluginInfos".
 *
 * @param writer The XML writer.
 * @param _pluginInfoListResponseDTO The PluginInfoListResponseDTO to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0PluginInfosElementNS(xmlTextWriterPtr writer, struct nexus_plugin_console_plugin_ns0_pluginInfoListResponseDTO *_pluginInfoListResponseDTO, int writeNamespaces);

/**
 * Frees the children of a PluginInfoListResponseDTO.
 *
 * @param _pluginInfoListResponseDTO The PluginInfoListResponseDTO whose children are to be free.
 */
static void freeNs0PluginInfosElement(struct nexus_plugin_console_plugin_ns0_pluginInfoListResponseDTO *_pluginInfoListResponseDTO);

/**
 * Reads a PluginInfoListResponseDTO from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The PluginInfoListResponseDTO, or NULL in case of error.
 */
static struct nexus_plugin_console_plugin_ns0_pluginInfoListResponseDTO *xmlTextReaderReadNs0PluginInfoListResponseDTOType(xmlTextReaderPtr reader);

/**
 * Writes a PluginInfoListResponseDTO to XML.
 *
 * @param writer The XML writer.
 * @param _pluginInfoListResponseDTO The PluginInfoListResponseDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0PluginInfoListResponseDTOType(xmlTextWriterPtr writer, struct nexus_plugin_console_plugin_ns0_pluginInfoListResponseDTO *_pluginInfoListResponseDTO);

/**
 * Frees the elements of a PluginInfoListResponseDTO.
 *
 * @param _pluginInfoListResponseDTO The PluginInfoListResponseDTO to free.
 */
static void freeNs0PluginInfoListResponseDTOType(struct nexus_plugin_console_plugin_ns0_pluginInfoListResponseDTO *_pluginInfoListResponseDTO);

#endif /* DEF_nexus_plugin_console_plugin_ns0_pluginInfoListResponseDTO_H */
#ifndef DEF_nexus_plugin_console_plugin_ns0_restInfo_H
#define DEF_nexus_plugin_console_plugin_ns0_restInfo_H

/**
 * (no documentation provided)
 */
struct nexus_plugin_console_plugin_ns0_restInfo {


  /**
   * (no documentation provided)
   */
  xmlChar *URI;

  /**
   * (no documentation provided)
   */
  xmlChar *description;
};

/**
 * Reads a RestInfoDTO from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The RestInfoDTO, or NULL in case of error.
 */
static struct nexus_plugin_console_plugin_ns0_restInfo *xmlTextReaderReadNs0RestInfoType(xmlTextReaderPtr reader);

/**
 * Writes a RestInfoDTO to XML.
 *
 * @param writer The XML writer.
 * @param _restInfoDTO The RestInfoDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0RestInfoType(xmlTextWriterPtr writer, struct nexus_plugin_console_plugin_ns0_restInfo *_restInfoDTO);

/**
 * Frees the elements of a RestInfoDTO.
 *
 * @param _restInfoDTO The RestInfoDTO to free.
 */
static void freeNs0RestInfoType(struct nexus_plugin_console_plugin_ns0_restInfo *_restInfoDTO);

#endif /* DEF_nexus_plugin_console_plugin_ns0_restInfo_H */
#ifndef DEF_nexus_plugin_console_plugin_ns0_pluginDocumentation_M
#define DEF_nexus_plugin_console_plugin_ns0_pluginDocumentation_M

/**
 * Reads a DocumentationLinkDTO from XML. The reader is assumed to be at the start element.
 *
 * @return the DocumentationLinkDTO, or NULL in case of error.
 */
static struct nexus_plugin_console_plugin_ns0_pluginDocumentation *xmlTextReaderReadNs0PluginDocumentationType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_plugin_console_plugin_ns0_pluginDocumentation *_documentationLinkDTO = calloc(1, sizeof(struct nexus_plugin_console_plugin_ns0_pluginDocumentation));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0PluginDocumentationType(_documentationLinkDTO);
        free(_documentationLinkDTO);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "label", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}label of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}label of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0PluginDocumentationType(_documentationLinkDTO);
          free(_documentationLinkDTO);
          return NULL;
        }

        _documentationLinkDTO->label = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "url", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}url of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}url of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0PluginDocumentationType(_documentationLinkDTO);
          free(_documentationLinkDTO);
          return NULL;
        }

        _documentationLinkDTO->url = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}pluginDocumentation.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}pluginDocumentation. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _documentationLinkDTO;
}

/**
 * Writes a DocumentationLinkDTO to XML.
 *
 * @param writer The XML writer.
 * @param _documentationLinkDTO The DocumentationLinkDTO to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0PluginDocumentationType(xmlTextWriterPtr writer, struct nexus_plugin_console_plugin_ns0_pluginDocumentation *_documentationLinkDTO) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_documentationLinkDTO->label != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "label", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}label. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}label...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_documentationLinkDTO->label));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}label. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}label. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_documentationLinkDTO->url != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "url", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}url. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}url...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_documentationLinkDTO->url));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}url. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}url. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a DocumentationLinkDTO.
 *
 * @param _documentationLinkDTO The DocumentationLinkDTO to free.
 */
static void freeNs0PluginDocumentationType(struct nexus_plugin_console_plugin_ns0_pluginDocumentation *_documentationLinkDTO) {
  int i;
  if (_documentationLinkDTO->label != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor label of type nexus_plugin_console_plugin_ns0_pluginDocumentation...\n");
#endif
    freeXsStringType(_documentationLinkDTO->label);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor label of type nexus_plugin_console_plugin_ns0_pluginDocumentation...\n");
#endif
    free(_documentationLinkDTO->label);
  }
  if (_documentationLinkDTO->url != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor url of type nexus_plugin_console_plugin_ns0_pluginDocumentation...\n");
#endif
    freeXsStringType(_documentationLinkDTO->url);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor url of type nexus_plugin_console_plugin_ns0_pluginDocumentation...\n");
#endif
    free(_documentationLinkDTO->url);
  }
}
#endif /* DEF_nexus_plugin_console_plugin_ns0_pluginDocumentation_M */
#ifndef DEF_nexus_plugin_console_plugin_ns0_pluginInfo_M
#define DEF_nexus_plugin_console_plugin_ns0_pluginInfo_M

/**
 * Reads a PluginInfoDTO from XML. The reader is assumed to be at the start element.
 *
 * @return the PluginInfoDTO, or NULL in case of error.
 */
static struct nexus_plugin_console_plugin_ns0_pluginInfo *xmlTextReaderReadNs0PluginInfoType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_plugin_console_plugin_ns0_pluginInfo *_pluginInfoDTO = calloc(1, sizeof(struct nexus_plugin_console_plugin_ns0_pluginInfo));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0PluginInfoType(_pluginInfoDTO);
        free(_pluginInfoDTO);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "site", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}site of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}site of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0PluginInfoType(_pluginInfoDTO);
          free(_pluginInfoDTO);
          return NULL;
        }

        _pluginInfoDTO->site = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "failureReason", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}failureReason of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}failureReason of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0PluginInfoType(_pluginInfoDTO);
          free(_pluginInfoDTO);
          return NULL;
        }

        _pluginInfoDTO->failureReason = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "status", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}status of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}status of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0PluginInfoType(_pluginInfoDTO);
          free(_pluginInfoDTO);
          return NULL;
        }

        _pluginInfoDTO->status = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "name", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}name of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}name of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0PluginInfoType(_pluginInfoDTO);
          free(_pluginInfoDTO);
          return NULL;
        }

        _pluginInfoDTO->name = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "description", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}description of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}description of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0PluginInfoType(_pluginInfoDTO);
          free(_pluginInfoDTO);
          return NULL;
        }

        _pluginInfoDTO->description = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "version", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}version of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}version of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0PluginInfoType(_pluginInfoDTO);
          free(_pluginInfoDTO);
          return NULL;
        }

        _pluginInfoDTO->version = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "scmVersion", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}scmVersion of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}scmVersion of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0PluginInfoType(_pluginInfoDTO);
          free(_pluginInfoDTO);
          return NULL;
        }

        _pluginInfoDTO->scmVersion = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "scmTimestamp", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}scmTimestamp of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}scmTimestamp of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0PluginInfoType(_pluginInfoDTO);
          free(_pluginInfoDTO);
          return NULL;
        }

        _pluginInfoDTO->scmTimestamp = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "restInfos", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

        if (xmlTextReaderIsEmptyElement(reader) == 0) {
#if DEBUG_ENUNCIATE > 1
          printf("Unwrapping wrapper element {}restInfos...\n");
#endif
          //start wrapper element "{}restInfos"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
          while (xmlTextReaderDepth(reader) > (depth + 1)) {
            if (status < 1) {
              //panic: XML read error.
#if DEBUG_ENUNCIATE
              printf("Failure to advance to next child element.\n");
#endif
              freeNs0PluginInfoType(_pluginInfoDTO);
              free(_pluginInfoDTO);
              return NULL;
            }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "restInfo", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}restInfo of type {}restInfo.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0RestInfoType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}restInfo of type {}restInfo.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0PluginInfoType(_pluginInfoDTO);
          free(_pluginInfoDTO);
          return NULL;
        }

        _pluginInfoDTO->restInfos = realloc(_pluginInfoDTO->restInfos, (_pluginInfoDTO->_sizeof_restInfos + 1) * sizeof(struct nexus_plugin_console_plugin_ns0_restInfo));
        memcpy(&(_pluginInfoDTO->restInfos[_pluginInfoDTO->_sizeof_restInfos++]), _child_accessor, sizeof(struct nexus_plugin_console_plugin_ns0_restInfo));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
          } // end "while in wrapper element" loop
        } //end "if empty element" clause

        if (status < 1) {
          //panic: XML read error.
#if DEBUG_ENUNCIATE
          printf("Failed to advance to end wrapper element {}restInfos.\n");
#endif
          freeNs0PluginInfoType(_pluginInfoDTO);
          free(_pluginInfoDTO);
          return NULL;
        }
        else {
          //end wrapper element "{}restInfos"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
        }
      } // end "if wrapper element" clause
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "documentation", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}documentation of type {}pluginDocumentation.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0PluginDocumentationType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}documentation of type {}pluginDocumentation.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0PluginInfoType(_pluginInfoDTO);
          free(_pluginInfoDTO);
          return NULL;
        }

        _pluginInfoDTO->documentation = realloc(_pluginInfoDTO->documentation, (_pluginInfoDTO->_sizeof_documentation + 1) * sizeof(struct nexus_plugin_console_plugin_ns0_pluginDocumentation));
        memcpy(&(_pluginInfoDTO->documentation[_pluginInfoDTO->_sizeof_documentation++]), _child_accessor, sizeof(struct nexus_plugin_console_plugin_ns0_pluginDocumentation));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}pluginInfo.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}pluginInfo. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _pluginInfoDTO;
}

/**
 * Writes a PluginInfoDTO to XML.
 *
 * @param writer The XML writer.
 * @param _pluginInfoDTO The PluginInfoDTO to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0PluginInfoType(xmlTextWriterPtr writer, struct nexus_plugin_console_plugin_ns0_pluginInfo *_pluginInfoDTO) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_pluginInfoDTO->site != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "site", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}site. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}site...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_pluginInfoDTO->site));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}site. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}site. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_pluginInfoDTO->failureReason != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "failureReason", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}failureReason. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}failureReason...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_pluginInfoDTO->failureReason));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}failureReason. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}failureReason. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_pluginInfoDTO->status != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "status", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}status. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}status...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_pluginInfoDTO->status));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}status. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}status. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_pluginInfoDTO->name != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "name", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}name...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_pluginInfoDTO->name));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_pluginInfoDTO->description != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "description", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}description. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}description...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_pluginInfoDTO->description));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}description. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}description. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_pluginInfoDTO->version != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "version", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}version. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}version...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_pluginInfoDTO->version));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}version. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}version. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_pluginInfoDTO->scmVersion != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "scmVersion", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}scmVersion. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}scmVersion...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_pluginInfoDTO->scmVersion));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}scmVersion. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}scmVersion. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_pluginInfoDTO->scmTimestamp != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "scmTimestamp", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}scmTimestamp. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}scmTimestamp...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_pluginInfoDTO->scmTimestamp));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}scmTimestamp. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}scmTimestamp. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_pluginInfoDTO->restInfos != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "restInfos", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}restInfos. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  for (i = 0; i < _pluginInfoDTO->_sizeof_restInfos; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "restInfo", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}restInfo. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}restInfo for element {}restInfo...\n", status);
#endif
    status = xmlTextWriterWriteNs0RestInfoType(writer, &(_pluginInfoDTO->restInfos[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}restInfo for element {}restInfo. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}restInfo. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_pluginInfoDTO->restInfos != NULL) {
    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}restInfos. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  for (i = 0; i < _pluginInfoDTO->_sizeof_documentation; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "documentation", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}documentation. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}pluginDocumentation for element {}documentation...\n", status);
#endif
    status = xmlTextWriterWriteNs0PluginDocumentationType(writer, &(_pluginInfoDTO->documentation[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}pluginDocumentation for element {}documentation. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}documentation. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a PluginInfoDTO.
 *
 * @param _pluginInfoDTO The PluginInfoDTO to free.
 */
static void freeNs0PluginInfoType(struct nexus_plugin_console_plugin_ns0_pluginInfo *_pluginInfoDTO) {
  int i;
  if (_pluginInfoDTO->site != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor site of type nexus_plugin_console_plugin_ns0_pluginInfo...\n");
#endif
    freeXsStringType(_pluginInfoDTO->site);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor site of type nexus_plugin_console_plugin_ns0_pluginInfo...\n");
#endif
    free(_pluginInfoDTO->site);
  }
  if (_pluginInfoDTO->failureReason != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor failureReason of type nexus_plugin_console_plugin_ns0_pluginInfo...\n");
#endif
    freeXsStringType(_pluginInfoDTO->failureReason);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor failureReason of type nexus_plugin_console_plugin_ns0_pluginInfo...\n");
#endif
    free(_pluginInfoDTO->failureReason);
  }
  if (_pluginInfoDTO->status != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor status of type nexus_plugin_console_plugin_ns0_pluginInfo...\n");
#endif
    freeXsStringType(_pluginInfoDTO->status);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor status of type nexus_plugin_console_plugin_ns0_pluginInfo...\n");
#endif
    free(_pluginInfoDTO->status);
  }
  if (_pluginInfoDTO->name != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor name of type nexus_plugin_console_plugin_ns0_pluginInfo...\n");
#endif
    freeXsStringType(_pluginInfoDTO->name);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor name of type nexus_plugin_console_plugin_ns0_pluginInfo...\n");
#endif
    free(_pluginInfoDTO->name);
  }
  if (_pluginInfoDTO->description != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor description of type nexus_plugin_console_plugin_ns0_pluginInfo...\n");
#endif
    freeXsStringType(_pluginInfoDTO->description);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor description of type nexus_plugin_console_plugin_ns0_pluginInfo...\n");
#endif
    free(_pluginInfoDTO->description);
  }
  if (_pluginInfoDTO->version != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor version of type nexus_plugin_console_plugin_ns0_pluginInfo...\n");
#endif
    freeXsStringType(_pluginInfoDTO->version);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor version of type nexus_plugin_console_plugin_ns0_pluginInfo...\n");
#endif
    free(_pluginInfoDTO->version);
  }
  if (_pluginInfoDTO->scmVersion != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor scmVersion of type nexus_plugin_console_plugin_ns0_pluginInfo...\n");
#endif
    freeXsStringType(_pluginInfoDTO->scmVersion);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor scmVersion of type nexus_plugin_console_plugin_ns0_pluginInfo...\n");
#endif
    free(_pluginInfoDTO->scmVersion);
  }
  if (_pluginInfoDTO->scmTimestamp != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor scmTimestamp of type nexus_plugin_console_plugin_ns0_pluginInfo...\n");
#endif
    freeXsStringType(_pluginInfoDTO->scmTimestamp);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor scmTimestamp of type nexus_plugin_console_plugin_ns0_pluginInfo...\n");
#endif
    free(_pluginInfoDTO->scmTimestamp);
  }
  if (_pluginInfoDTO->restInfos != NULL) {
    for (i = 0; i < _pluginInfoDTO->_sizeof_restInfos; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor restInfos[%i] of type nexus_plugin_console_plugin_ns0_pluginInfo...\n", i);
#endif
      freeNs0RestInfoType(&(_pluginInfoDTO->restInfos[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor restInfos of type nexus_plugin_console_plugin_ns0_pluginInfo...\n");
#endif
    free(_pluginInfoDTO->restInfos);
  }
  if (_pluginInfoDTO->documentation != NULL) {
    for (i = 0; i < _pluginInfoDTO->_sizeof_documentation; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor documentation[%i] of type nexus_plugin_console_plugin_ns0_pluginInfo...\n", i);
#endif
      freeNs0PluginDocumentationType(&(_pluginInfoDTO->documentation[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor documentation of type nexus_plugin_console_plugin_ns0_pluginInfo...\n");
#endif
    free(_pluginInfoDTO->documentation);
  }
}
#endif /* DEF_nexus_plugin_console_plugin_ns0_pluginInfo_M */
#ifndef DEF_nexus_plugin_console_plugin_ns0_pluginInfoListResponseDTO_M
#define DEF_nexus_plugin_console_plugin_ns0_pluginInfoListResponseDTO_M

/**
 * Reads a PluginInfoListResponseDTO element from XML. The element to be read is "pluginInfos", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The PluginInfoListResponseDTO, or NULL in case of error.
 */
struct nexus_plugin_console_plugin_ns0_pluginInfoListResponseDTO *xml_read_nexus_plugin_console_plugin_ns0_pluginInfoListResponseDTO(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0PluginInfosElement(reader);
}

/**
 * Writes a PluginInfoListResponseDTO to XML under element name "pluginInfos".
 *
 * @param writer The XML writer.
 * @param _pluginInfoListResponseDTO The PluginInfoListResponseDTO to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_plugin_console_plugin_ns0_pluginInfoListResponseDTO(xmlTextWriterPtr writer, struct nexus_plugin_console_plugin_ns0_pluginInfoListResponseDTO *_pluginInfoListResponseDTO) {
  return xmlTextWriterWriteNs0PluginInfosElementNS(writer, _pluginInfoListResponseDTO, 1);
}

/**
 * Frees a PluginInfoListResponseDTO.
 *
 * @param _pluginInfoListResponseDTO The PluginInfoListResponseDTO to free.
 */
void free_nexus_plugin_console_plugin_ns0_pluginInfoListResponseDTO(struct nexus_plugin_console_plugin_ns0_pluginInfoListResponseDTO *_pluginInfoListResponseDTO) {
  freeNs0PluginInfoListResponseDTOType(_pluginInfoListResponseDTO);
  free(_pluginInfoListResponseDTO);
}

/**
 * Reads a PluginInfoListResponseDTO element from XML. The element to be read is "pluginInfos", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The PluginInfoListResponseDTO, or NULL in case of error.
 */
struct nexus_plugin_console_plugin_ns0_pluginInfoListResponseDTO *xmlTextReaderReadNs0PluginInfosElement(xmlTextReaderPtr reader) {
  struct nexus_plugin_console_plugin_ns0_pluginInfoListResponseDTO *_pluginInfoListResponseDTO = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "pluginInfos", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}pluginInfos.\n");
#endif
    _pluginInfoListResponseDTO = xmlTextReaderReadNs0PluginInfoListResponseDTOType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_pluginInfoListResponseDTO == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}pluginInfos failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}pluginInfos failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _pluginInfoListResponseDTO;
}

/**
 * Writes a PluginInfoListResponseDTO to XML under element name "pluginInfos".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _pluginInfoListResponseDTO The PluginInfoListResponseDTO to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0PluginInfosElement(xmlTextWriterPtr writer, struct nexus_plugin_console_plugin_ns0_pluginInfoListResponseDTO *_pluginInfoListResponseDTO) {
  return xmlTextWriterWriteNs0PluginInfosElementNS(writer, _pluginInfoListResponseDTO, 0);
}

/**
 * Writes a PluginInfoListResponseDTO to XML under element name "pluginInfos".
 *
 * @param writer The XML writer.
 * @param _pluginInfoListResponseDTO The PluginInfoListResponseDTO to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0PluginInfosElementNS(xmlTextWriterPtr writer, struct nexus_plugin_console_plugin_ns0_pluginInfoListResponseDTO *_pluginInfoListResponseDTO, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "pluginInfos", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}pluginInfos. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}pluginInfoListResponseDTO for root element {}pluginInfos...\n");
#endif
  status = xmlTextWriterWriteNs0PluginInfoListResponseDTOType(writer, _pluginInfoListResponseDTO);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}pluginInfos. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}pluginInfos. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a PluginInfoListResponseDTO.
 *
 * @param _pluginInfoListResponseDTO The PluginInfoListResponseDTO whose children are to be free.
 */
static void freeNs0PluginInfosElement(struct nexus_plugin_console_plugin_ns0_pluginInfoListResponseDTO *_pluginInfoListResponseDTO) {
  freeNs0PluginInfoListResponseDTOType(_pluginInfoListResponseDTO);
}

/**
 * Reads a PluginInfoListResponseDTO from XML. The reader is assumed to be at the start element.
 *
 * @return the PluginInfoListResponseDTO, or NULL in case of error.
 */
static struct nexus_plugin_console_plugin_ns0_pluginInfoListResponseDTO *xmlTextReaderReadNs0PluginInfoListResponseDTOType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_plugin_console_plugin_ns0_pluginInfoListResponseDTO *_pluginInfoListResponseDTO = calloc(1, sizeof(struct nexus_plugin_console_plugin_ns0_pluginInfoListResponseDTO));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0PluginInfoListResponseDTOType(_pluginInfoListResponseDTO);
        free(_pluginInfoListResponseDTO);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

        if (xmlTextReaderIsEmptyElement(reader) == 0) {
#if DEBUG_ENUNCIATE > 1
          printf("Unwrapping wrapper element {}data...\n");
#endif
          //start wrapper element "{}data"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
          while (xmlTextReaderDepth(reader) > (depth + 1)) {
            if (status < 1) {
              //panic: XML read error.
#if DEBUG_ENUNCIATE
              printf("Failure to advance to next child element.\n");
#endif
              freeNs0PluginInfoListResponseDTOType(_pluginInfoListResponseDTO);
              free(_pluginInfoListResponseDTO);
              return NULL;
            }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "pluginInfo", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}pluginInfo of type {}pluginInfo.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0PluginInfoType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}pluginInfo of type {}pluginInfo.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0PluginInfoListResponseDTOType(_pluginInfoListResponseDTO);
          free(_pluginInfoListResponseDTO);
          return NULL;
        }

        _pluginInfoListResponseDTO->data = realloc(_pluginInfoListResponseDTO->data, (_pluginInfoListResponseDTO->_sizeof_data + 1) * sizeof(struct nexus_plugin_console_plugin_ns0_pluginInfo));
        memcpy(&(_pluginInfoListResponseDTO->data[_pluginInfoListResponseDTO->_sizeof_data++]), _child_accessor, sizeof(struct nexus_plugin_console_plugin_ns0_pluginInfo));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
          } // end "while in wrapper element" loop
        } //end "if empty element" clause

        if (status < 1) {
          //panic: XML read error.
#if DEBUG_ENUNCIATE
          printf("Failed to advance to end wrapper element {}data.\n");
#endif
          freeNs0PluginInfoListResponseDTOType(_pluginInfoListResponseDTO);
          free(_pluginInfoListResponseDTO);
          return NULL;
        }
        else {
          //end wrapper element "{}data"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
        }
      } // end "if wrapper element" clause
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}pluginInfoListResponseDTO.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}pluginInfoListResponseDTO. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _pluginInfoListResponseDTO;
}

/**
 * Writes a PluginInfoListResponseDTO to XML.
 *
 * @param writer The XML writer.
 * @param _pluginInfoListResponseDTO The PluginInfoListResponseDTO to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0PluginInfoListResponseDTOType(xmlTextWriterPtr writer, struct nexus_plugin_console_plugin_ns0_pluginInfoListResponseDTO *_pluginInfoListResponseDTO) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;

  if (_pluginInfoListResponseDTO->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  for (i = 0; i < _pluginInfoListResponseDTO->_sizeof_data; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "pluginInfo", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}pluginInfo. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}pluginInfo for element {}pluginInfo...\n", status);
#endif
    status = xmlTextWriterWriteNs0PluginInfoType(writer, &(_pluginInfoListResponseDTO->data[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}pluginInfo for element {}pluginInfo. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}pluginInfo. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_pluginInfoListResponseDTO->data != NULL) {
    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a PluginInfoListResponseDTO.
 *
 * @param _pluginInfoListResponseDTO The PluginInfoListResponseDTO to free.
 */
static void freeNs0PluginInfoListResponseDTOType(struct nexus_plugin_console_plugin_ns0_pluginInfoListResponseDTO *_pluginInfoListResponseDTO) {
  int i;
  if (_pluginInfoListResponseDTO->data != NULL) {
    for (i = 0; i < _pluginInfoListResponseDTO->_sizeof_data; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor data[%i] of type nexus_plugin_console_plugin_ns0_pluginInfoListResponseDTO...\n", i);
#endif
      freeNs0PluginInfoType(&(_pluginInfoListResponseDTO->data[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type nexus_plugin_console_plugin_ns0_pluginInfoListResponseDTO...\n");
#endif
    free(_pluginInfoListResponseDTO->data);
  }
}
#endif /* DEF_nexus_plugin_console_plugin_ns0_pluginInfoListResponseDTO_M */
#ifndef DEF_nexus_plugin_console_plugin_ns0_restInfo_M
#define DEF_nexus_plugin_console_plugin_ns0_restInfo_M

/**
 * Reads a RestInfoDTO from XML. The reader is assumed to be at the start element.
 *
 * @return the RestInfoDTO, or NULL in case of error.
 */
static struct nexus_plugin_console_plugin_ns0_restInfo *xmlTextReaderReadNs0RestInfoType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_plugin_console_plugin_ns0_restInfo *_restInfoDTO = calloc(1, sizeof(struct nexus_plugin_console_plugin_ns0_restInfo));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0RestInfoType(_restInfoDTO);
        free(_restInfoDTO);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "URI", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}URI of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}URI of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0RestInfoType(_restInfoDTO);
          free(_restInfoDTO);
          return NULL;
        }

        _restInfoDTO->URI = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "description", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}description of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}description of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0RestInfoType(_restInfoDTO);
          free(_restInfoDTO);
          return NULL;
        }

        _restInfoDTO->description = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}restInfo.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}restInfo. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _restInfoDTO;
}

/**
 * Writes a RestInfoDTO to XML.
 *
 * @param writer The XML writer.
 * @param _restInfoDTO The RestInfoDTO to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0RestInfoType(xmlTextWriterPtr writer, struct nexus_plugin_console_plugin_ns0_restInfo *_restInfoDTO) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_restInfoDTO->URI != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "URI", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}URI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}URI...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_restInfoDTO->URI));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}URI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}URI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_restInfoDTO->description != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "description", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}description. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}description...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_restInfoDTO->description));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}description. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}description. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a RestInfoDTO.
 *
 * @param _restInfoDTO The RestInfoDTO to free.
 */
static void freeNs0RestInfoType(struct nexus_plugin_console_plugin_ns0_restInfo *_restInfoDTO) {
  int i;
  if (_restInfoDTO->URI != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor URI of type nexus_plugin_console_plugin_ns0_restInfo...\n");
#endif
    freeXsStringType(_restInfoDTO->URI);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor URI of type nexus_plugin_console_plugin_ns0_restInfo...\n");
#endif
    free(_restInfoDTO->URI);
  }
  if (_restInfoDTO->description != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor description of type nexus_plugin_console_plugin_ns0_restInfo...\n");
#endif
    freeXsStringType(_restInfoDTO->description);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor description of type nexus_plugin_console_plugin_ns0_restInfo...\n");
#endif
    free(_restInfoDTO->description);
  }
}
#endif /* DEF_nexus_plugin_console_plugin_ns0_restInfo_M */
